unit fingerclient;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Winsock;


const
     WM_USER=1024;
     WM_USERHOST=1026;

type
  TFingerClient = class(TComponent)
  private
    { Private declarations }
    flines,fhost,fuser:string;
    fport:integer;
    FHandle: HWnd;
    fclosed,ffc,ffingered,ferror:TNotifyEvent;
    EsticEnWSA,cancelat:boolean;
    FingerS:integer;   //socket
    procedure WMUSER(var Tm:tmessage);message WM_USER;
    procedure WMUSERHOST(var Tm:tmessage);message WM_USERHOST;
    function  EsperaWSA(s,event:integer):integer;
    procedure RessetejaWSA(s:integer);
    function  ConnectTo(serv:string):boolean;
    procedure WndProc(var Message: TMessage);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Response:String read flines write flines;
    property Canceled:boolean read cancelat write cancelat;
    property Handle: HWnd read FHandle;

    function DoFinger(Host:string;Text:string):string;
    function FingerIt:string;
    procedure Cancel;

  published
    { Published declarations }
    property FingerHost:string read fhost write fhost;
    property FingerUser:string read fuser write fuser;
    property FingerPort:integer read fport write fport default 79;

    property OnError:TNotifyEvent read ferror write ferror;
    property OnClose:TNotifyEvent read fclosed write fclosed;
    property OnFingerCall:TNotifyEvent read ffc write ffc;
    property OnFingered:TNotifyEvent read ffingered write ffingered;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('UsefulTools', [TFingerClient]);
end;

constructor tfingerclient.create(AOwner:TComponent);
begin
  inherited Create(Aowner);
  fport:=79;
  FHandle := AllocateHWnd(WndProc);
end;

destructor tfingerclient.destroy;
begin
     inherited Destroy;
     DeallocateHWnd(FHandle);
end;

function Tfingerclient.EsperaWSA(s,event:integer):integer;
begin
     result:=1;//OK
     EsticEnWSA:=true;
     if WSAAsyncSelect(s,handle,WM_USER,event or FD_CLOSE)=SOCKET_ERROR then
     begin
         //error
         result:=-1;    //error
         exit;
     end;
     while EsticEnWSA do
     begin
          if (cancelat) then
          begin
               ressetejaWSA(s);
               result:=0; //cancelat
               exit;
          end;
           application.processmessages;
     end;
end;

procedure tfingerclient.WMUSERHOST(var Tm:tmessage);
begin
     esticenwsa:=false;
end;

procedure Tfingerclient.RessetejaWSA(s:integer);
var
   nr:u_long;
begin
     if WSAAsyncSelect(s,handle,FD_CLOSE,0)=SOCKET_ERROR then
     begin
          //error
          exit;
     end;
     nr:=0;
     ioctlsocket(s,FIONBIO,nr);                   //blocking

end;

procedure Tfingerclient.WMUSER(var Tm:tmessage);
var
   ev,er:integer;
   cad:string;

begin
     ev:=wsagetselectevent(tm.lparam);
     er:=WSAGETSELECTERROR(tm.lparam);
     if er<>0 then
     begin
        if ev=FD_CLOSE then
           cad:='closing.'
        else if ev=FD_READ then
           cad:='reading.'
        else if ev=FD_WRITE then
           cad:='writing.'
        else if ev=FD_CONNECT then
           cad:='connecting [CONNECT].';
        showmessage('ERROR '+inttostr(er)+' while '+cad);
        cancelat:=true;
     end;

     if ev=FD_CLOSE then
     begin
          cancelat:=true;
          beep;
          if assigned(fclosed) then fclosed(self);
     end;

          EsticEnWSA:=false;
end;

function Tfingerclient.ConnectTo(serv:string):boolean;
var
   nr:longint;
   s:integer;
   addr:TSockAddrIn;
   WSData:TWSAData;
   ip:string;
   hpa:array[0..1024]of char;
begin
     cancelat:=false;
     WSAStartup(MAKEWORD(1,1),WSData);
//-------creo el socket-----------
     s:=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
     if s=INVALID_SOCKET then
     begin
          //error
          showmessage('>ERROR '+inttostr(WSAGetLastError)+' : socket not connected.');
          closesocket(s);
          result:=false;
          beep;
          if assigned(ferror) then ferror(self);
          exit;
     end;
         addr.sin_family:=AF_INET;
         addr.sin_port:=htons(FingerPort);
         if ((serv[1]>='0')and(serv[1]<='9')) then
         begin
              ip:=serv;
              addr.sin_addr.s_addr:=inet_addr(pchar(serv));
         end else
         begin
                EsticenWSA:=true;
                hpa:='';
                WSAAsyncGetHostByName(handle,WM_USERHOST,pchar(serv),hpa,length(hpa));
                while EsticEnWSA do
                begin
                     if (cancelat) then
                     begin
                          closesocket(s);
                          beep;
                          if assigned(ferror) then ferror(self);
                          result:=false;
                          exit;
                     end;                
                     application.processmessages;
                end;
                if WSAAsyncSelect(s,handle,FD_CLOSE,0)=SOCKET_ERROR then
                begin
                     //error
                     showmessage('>ERROR '+inttostr(WSAGetLastError)+' WSAAsyncSelect');
                     beep;
                     if assigned(ferror) then ferror(self);
                     result:=false;
                     closesocket(s);
                     exit;
                end;
                nr:=0;
                ioctlsocket(s,FIONBIO,nr);                   //blocking
              ip:=inttostr(ord(hpa[28]))+'.'
                  +inttostr(ord(hpa[29]))+'.'
                  +inttostr(ord(hpa[30]))+'.'
                  +inttostr(ord(hpa[31]));
              addr.sin_addr.s_addr:=inet_addr(pchar (ip));
         end;
     EsticEnWSA:=true;
     if WSAAsyncSelect(s,handle,1024,FD_CONNECT or FD_CLOSE)=SOCKET_ERROR then
     begin
         //error
         closesocket(s);
         beep;
         if assigned(ferror) then ferror(self);
         result:=false;
         showmessage('>ERROR '+inttostr(WSAGetLastError)+' : socket not connected.');
         exit;
     end;
     connect(s,addr,sizeof(addr));
     while EsticEnWSA do
     begin
          if (cancelat) then
          begin
               closesocket(s);
               beep;
               if assigned(ferror) then ferror(self);
               result:=false;
               exit;
          end;
           application.processmessages;
     end;
//-------creo ho deixo preparat per al Telnet-----------
     if WSAAsyncSelect(s,handle,FD_CLOSE,0)=SOCKET_ERROR then
     begin
          //error
          showmessage('>ERROR '+inttostr(WSAGetLastError)+' WSAAsyncSelect');
          beep;
          if assigned(ferror) then ferror(self);
          closesocket(s);
          result:=false;
          exit;
     end;
     FingerS:=s;
     nr:=0;
     ioctlsocket(s,FIONBIO,nr);                   //blocking
     result:=true;

end;

function Tfingerclient.FingerIt:string;
begin
    result:=DoFinger(fhost,fuser);
end;

function Tfingerclient.DoFinger(Host:string;Text:string):string;
var
   len,i:integer;
   buf:array[0..1024]of char;
   cad2:string;
begin
     if assigned(ffc) then ffc(self);
     flines:='';
     If ConnectTo(Host) then
     begin
          cad2:=text+#10+#13;
          buf:='';
          len:=length(cad2);
          for i:=0 to length(cad2)-1 do
              buf[i]:=cad2[i+1];
          esperaWSA(FingerS,FD_WRITE);
          send(Fingers,buf,len,0);
          RessetejaWSA(FingerS);
          buf:='';
          esperaWSA(FingerS,FD_READ);

          while recv(FingerS,buf,1024,0)>0 do
                flines:=buf;
          RessetejaWSA(FingerS);
          closesocket(FingerS);
          result:=flines;
     end else
          result:='';
     if assigned(ffingered) then ffingered(self);
end;

procedure tfingerclient.Cancel;
begin
     cancelat:=true;
end;

procedure tfingerclient.WndProc(var Message: TMessage);
begin
      with Message do
      if Msg = WM_USER then
      begin
           WMUSER(message);
      end else
          if Msg= WM_USERHOST then
          begin
               WMUSERHOST(message);
          end else
              Result := DefWindowProc(FHandle, Msg, wParam, lParam);
          
end;

end.
